//Title: Device Manager Class
//Platform: BeOS 5
//Version: 2001.02.03
//Description:
//	A class for working with physical hardware devices (like VGA displays)
//  Basically a factory class for the other Device classes.

//Copyright (C) 2002 Kevin H. Patterson

#include <dirent.h>
#include <string.h>

//#include <iostream.h>

#include "DeviceManager.h"

DeviceManager::DeviceManager() {
}

DeviceManager::~DeviceManager() {
}

GraphicsDevice * DeviceManager::GetGraphicsDevice(const char * DeviceName) {
	GraphicsDevice * tGraphicsDevice(new GraphicsDevice(DeviceName));
	if (tGraphicsDevice != NULL) {
		if (tGraphicsDevice->InitCheck())
			return tGraphicsDevice;
		else {
			delete tGraphicsDevice;
			return NULL;
		}
	}
	else
		return NULL;
}

GraphicsDevice * DeviceManager::GetGraphicsDevice(uint32 DeviceIndex) {
	GraphicsDevice * tGraphicsDevice(NULL);

	uint32 DeviceCount(0);
	const char * DevicePath = "/dev/graphics";
	DIR * DeviceDirectory;
	DeviceDirectory = opendir(DevicePath);
	if (DeviceDirectory != NULL) {
		char DeviceName[1024];
		struct dirent	*DeviceEntry;
		while (((DeviceEntry = readdir(DeviceDirectory)) != NULL) && (tGraphicsDevice == NULL)) {
			if (strcmp(DeviceEntry->d_name, ".") && strcmp(DeviceEntry->d_name, "..") && strcmp(DeviceEntry->d_name, "stub")) {
//				cout << DeviceCount << ": " << DeviceEntry->d_name << endl;
				if (DeviceCount == DeviceIndex) {
					strcpy(DeviceName, DevicePath);
					strcat(DeviceName, "/");
					strcat(DeviceName, DeviceEntry->d_name);
					tGraphicsDevice = new GraphicsDevice(DeviceName);
				}
				DeviceCount ++;
			}
		}
		closedir(DeviceDirectory);
	}

	if (tGraphicsDevice != NULL) {
		if (tGraphicsDevice->InitCheck())
			return tGraphicsDevice;
		else {
			delete tGraphicsDevice;
			return NULL;
		}
	}
	else
		return NULL;
}

uint32 DeviceManager::GraphicsDeviceCount() {
	uint32 DeviceCount(0);
	const char * DevicePath = "/dev/graphics";
	DIR * DeviceDirectory;
	DeviceDirectory = opendir(DevicePath);
	if (DeviceDirectory != NULL) {
		struct dirent	*DeviceEntry;
		while ((DeviceEntry = readdir(DeviceDirectory)) != NULL) {
			if (strcmp(DeviceEntry->d_name, ".") && strcmp(DeviceEntry->d_name, "..") && strcmp(DeviceEntry->d_name, "stub"))
				DeviceCount ++;
		}
		closedir(DeviceDirectory);
	}
	return DeviceCount;
}
